// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2023 Levente Bajczi, Department of Measurement and Information Systems, Budapest University of Technology and Economics
//
// SPDX-License-Identifier: Apache-2.0

// Original CHC file: vmt-chc-benchmarks/string_concat-noarr.c_000.smt2
extern void abort ();
extern int __VERIFIER_nondet_int ();
extern _Bool __VERIFIER_nondet__Bool ();
extern void __assert_fail(const char *, const char *, unsigned int, const char *) __attribute__ ((__nothrow__ , __leaf__)) __attribute__ ((__noreturn__));
void reach_error() { __assert_fail("0", "string_concat-noarr.c_000_range.c", 13, "reach_error"); }



int main ();

int
main ()
{
    // return parameter


    // variables
    _Bool state_0;
    _Bool state_1;
    _Bool state_2;
    _Bool state_3;
    _Bool state_4;
    int state_5;
    int state_6;
    _Bool A_0;
    _Bool B_0;
    _Bool C_0;
    int D_0;
    int E_0;
    _Bool F_0;
    _Bool G_0;
    _Bool A_1;
    _Bool B_1;
    _Bool C_1;
    _Bool D_1;
    _Bool E_1;
    _Bool F_1;
    _Bool G_1;
    _Bool H_1;
    int I_1;
    int J_1;
    int K_1;
    int L_1;
    int M_1;
    _Bool N_1;
    _Bool O_1;
    _Bool A_2;
    _Bool B_2;
    _Bool C_2;
    int D_2;
    int E_2;
    _Bool F_2;
    _Bool G_2;

    if (((state_5 <= -1000000000) || (state_5 >= 1000000000))
        || ((state_6 <= -1000000000) || (state_6 >= 1000000000))
        || ((D_0 <= -1000000000) || (D_0 >= 1000000000))
        || ((E_0 <= -1000000000) || (E_0 >= 1000000000))
        || ((I_1 <= -1000000000) || (I_1 >= 1000000000))
        || ((J_1 <= -1000000000) || (J_1 >= 1000000000))
        || ((K_1 <= -1000000000) || (K_1 >= 1000000000))
        || ((L_1 <= -1000000000) || (L_1 >= 1000000000))
        || ((M_1 <= -1000000000) || (M_1 >= 1000000000))
        || ((D_2 <= -1000000000) || (D_2 >= 1000000000))
        || ((E_2 <= -1000000000) || (E_2 >= 1000000000)))
        abort ();

    // main logic
    goto main_init;

  main_init:
    if (!(B_0 && (!A_0) && (!G_0) && (!F_0) && (!C_0)))
        abort ();
    state_0 = C_0;
    state_1 = B_0;
    state_2 = A_0;
    state_3 = G_0;
    state_4 = F_0;
    state_5 = D_0;
    state_6 = E_0;
    D_1 = __VERIFIER_nondet__Bool ();
    E_1 = __VERIFIER_nondet__Bool ();
    F_1 = __VERIFIER_nondet__Bool ();
    G_1 = __VERIFIER_nondet__Bool ();
    H_1 = __VERIFIER_nondet__Bool ();
    I_1 = __VERIFIER_nondet_int ();
    if (((I_1 <= -1000000000) || (I_1 >= 1000000000)))
        abort ();
    K_1 = __VERIFIER_nondet_int ();
    if (((K_1 <= -1000000000) || (K_1 >= 1000000000)))
        abort ();
    M_1 = __VERIFIER_nondet_int ();
    if (((M_1 <= -1000000000) || (M_1 >= 1000000000)))
        abort ();
    C_1 = state_0;
    B_1 = state_1;
    A_1 = state_2;
    O_1 = state_3;
    N_1 = state_4;
    J_1 = state_5;
    L_1 = state_6;
    if (!
        ((B_1 || N_1 || (!O_1) || (!A_1) || (!C_1) || (200 <= J_1)
          || ((!H_1) && G_1 && F_1 && E_1 && D_1 && (J_1 == I_1)
              && (L_1 == K_1))) && (B_1 || C_1 || N_1 || (!O_1) || (!A_1)
                                    || (100 <= L_1) || ((!H_1) && G_1 && F_1
                                                        && E_1 && (!D_1)
                                                        && (J_1 == I_1)
                                                        && (L_1 == K_1)))
         && (B_1 || C_1 || N_1 || (!O_1) || (!A_1) || (!(100 <= L_1))
             || ((!H_1) && G_1 && F_1 && (!E_1) && D_1 && (J_1 == I_1)
                 && (L_1 == K_1))) && (A_1 || B_1 || C_1 || N_1 || (!O_1)
                                       || (M_1 == 0) || ((!H_1) && G_1 && F_1
                                                         && (!E_1) && (!D_1)
                                                         && (J_1 == I_1)
                                                         && (L_1 == K_1)))
         && (A_1 || B_1 || C_1 || N_1 || (!O_1) || (!(M_1 == 0))
             || ((!H_1) && G_1 && (!F_1) && (!E_1) && D_1 && (J_1 == I_1)
                 && (L_1 == K_1))) && (C_1 || N_1 || O_1 || (!A_1) || (!B_1)
                                       || (100 <= J_1) || ((!H_1) && (!G_1)
                                                           && F_1 && E_1
                                                           && D_1
                                                           && (J_1 == I_1)
                                                           && (L_1 == K_1)))
         && (C_1 || N_1 || O_1 || (!A_1) || (!B_1) || (!(100 <= J_1))
             || ((!H_1) && (!G_1) && F_1 && E_1 && (!D_1) && (J_1 == I_1)
                 && (L_1 == K_1))) && (A_1 || B_1 || N_1 || O_1 || (!C_1)
                                       || (M_1 == 0) || ((!H_1) && (!G_1)
                                                         && F_1 && (!E_1)
                                                         && D_1
                                                         && (J_1 == I_1)
                                                         && (L_1 == K_1)))
         && (A_1 || B_1 || N_1 || O_1 || (!C_1) || (!(M_1 == 0))
             || ((!H_1) && (!G_1) && (!F_1) && E_1 && D_1 && (J_1 == I_1)
                 && (L_1 == K_1))) && (A_1 || C_1 || N_1 || (!O_1) || (!B_1)
                                       || ((!H_1) && G_1 && (!F_1) && E_1
                                           && (!D_1) && (L_1 == K_1)
                                           && ((J_1 + (-1 * I_1)) == -1)))
         && (A_1 || N_1 || O_1 || (!C_1) || (!B_1)
             || ((!H_1) && (!G_1) && F_1 && (!E_1) && (!D_1) && (L_1 == K_1)
                 && ((J_1 + (-1 * I_1)) == -1))) && (A_1 || B_1 || N_1
                                                     || (!O_1) || (!C_1)
                                                     || ((!H_1) && G_1
                                                         && (!F_1) && E_1
                                                         && D_1
                                                         && (J_1 == I_1)
                                                         &&
                                                         ((L_1 +
                                                           (-1 * K_1)) ==
                                                          -1))) && (A_1 || C_1
                                                                    || O_1
                                                                    || (!N_1)
                                                                    || (!B_1)
                                                                    || (H_1
                                                                        &&
                                                                        (!G_1)
                                                                        &&
                                                                        (!F_1)
                                                                        &&
                                                                        (!E_1)
                                                                        && D_1
                                                                        &&
                                                                        (J_1
                                                                         ==
                                                                         I_1)
                                                                        &&
                                                                        (L_1
                                                                         ==
                                                                         K_1)))
         && (N_1 || (!O_1) || (!A_1) || (!C_1) || (!B_1)
             || (H_1 && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1)
                 && (L_1 == K_1))) && (A_1 || N_1 || (!O_1) || (!C_1)
                                       || (!B_1) || ((!H_1) && G_1 && (!F_1)
                                                     && (!E_1) && (!D_1)
                                                     && (J_1 == I_1)
                                                     && (L_1 == K_1))) && (B_1
                                                                           ||
                                                                           C_1
                                                                           ||
                                                                           N_1
                                                                           ||
                                                                           O_1
                                                                           ||
                                                                           (!A_1)
                                                                           ||
                                                                           ((!H_1) && (!G_1) && (!F_1) && E_1 && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || B_1 || C_1 || N_1 || O_1 || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || B_1 || C_1 || O_1 || (!N_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (B_1 || N_1 || O_1 || (!A_1) || (!C_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (C_1 || N_1 || (!O_1) || (!A_1) || (!B_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || C_1 || N_1 || O_1 || (!B_1) || ((!H_1) && (!G_1) && (!F_1) && E_1 && (!D_1) && (I_1 == 0) && (L_1 == K_1))) && (N_1 || O_1 || (!A_1) || (!C_1) || (!B_1) || ((!H_1) && G_1 && (!F_1) && (!E_1) && (!D_1) && (K_1 == 0) && (J_1 == I_1))) && (B_1 || N_1 || (!O_1) || (!A_1) || (!C_1) || (!(200 <= J_1)) || (H_1 && (!G_1) && (!F_1) && (!E_1) && D_1 && (J_1 == I_1) && (L_1 == K_1)))))
        abort ();
    state_0 = E_1;
    state_1 = D_1;
    state_2 = F_1;
    state_3 = G_1;
    state_4 = H_1;
    state_5 = I_1;
    state_6 = K_1;
    goto state_0;
  main_error:
    reach_error ();
  main_final:
    goto main_final;
  state_0:
    switch (__VERIFIER_nondet__Bool ())
      {
      case 0:
          C_2 = state_0;
          B_2 = state_1;
          A_2 = state_2;
          G_2 = state_3;
          F_2 = state_4;
          D_2 = state_5;
          E_2 = state_6;
          if (!(B_2 && (!A_2) && (!G_2) && F_2 && (!C_2)))
              abort ();
          goto main_error;

      case 1:
          D_1 = __VERIFIER_nondet__Bool ();
          E_1 = __VERIFIER_nondet__Bool ();
          F_1 = __VERIFIER_nondet__Bool ();
          G_1 = __VERIFIER_nondet__Bool ();
          H_1 = __VERIFIER_nondet__Bool ();
          I_1 = __VERIFIER_nondet_int ();
          if (((I_1 <= -1000000000) || (I_1 >= 1000000000)))
              abort ();
          K_1 = __VERIFIER_nondet_int ();
          if (((K_1 <= -1000000000) || (K_1 >= 1000000000)))
              abort ();
          M_1 = __VERIFIER_nondet_int ();
          if (((M_1 <= -1000000000) || (M_1 >= 1000000000)))
              abort ();
          C_1 = state_0;
          B_1 = state_1;
          A_1 = state_2;
          O_1 = state_3;
          N_1 = state_4;
          J_1 = state_5;
          L_1 = state_6;
          if (!
              ((B_1 || N_1 || (!O_1) || (!A_1) || (!C_1) || (200 <= J_1)
                || ((!H_1) && G_1 && F_1 && E_1 && D_1 && (J_1 == I_1)
                    && (L_1 == K_1))) && (B_1 || C_1 || N_1 || (!O_1)
                                          || (!A_1) || (100 <= L_1) || ((!H_1)
                                                                        && G_1
                                                                        && F_1
                                                                        && E_1
                                                                        &&
                                                                        (!D_1)
                                                                        &&
                                                                        (J_1
                                                                         ==
                                                                         I_1)
                                                                        &&
                                                                        (L_1
                                                                         ==
                                                                         K_1)))
               && (B_1 || C_1 || N_1 || (!O_1) || (!A_1) || (!(100 <= L_1))
                   || ((!H_1) && G_1 && F_1 && (!E_1) && D_1 && (J_1 == I_1)
                       && (L_1 == K_1))) && (A_1 || B_1 || C_1 || N_1
                                             || (!O_1) || (M_1 == 0)
                                             || ((!H_1) && G_1 && F_1
                                                 && (!E_1) && (!D_1)
                                                 && (J_1 == I_1)
                                                 && (L_1 == K_1))) && (A_1
                                                                       || B_1
                                                                       || C_1
                                                                       || N_1
                                                                       ||
                                                                       (!O_1)
                                                                       ||
                                                                       (!(M_1
                                                                          ==
                                                                          0))
                                                                       ||
                                                                       ((!H_1)
                                                                        && G_1
                                                                        &&
                                                                        (!F_1)
                                                                        &&
                                                                        (!E_1)
                                                                        && D_1
                                                                        &&
                                                                        (J_1
                                                                         ==
                                                                         I_1)
                                                                        &&
                                                                        (L_1
                                                                         ==
                                                                         K_1)))
               && (C_1 || N_1 || O_1 || (!A_1) || (!B_1) || (100 <= J_1)
                   || ((!H_1) && (!G_1) && F_1 && E_1 && D_1 && (J_1 == I_1)
                       && (L_1 == K_1))) && (C_1 || N_1 || O_1 || (!A_1)
                                             || (!B_1) || (!(100 <= J_1))
                                             || ((!H_1) && (!G_1) && F_1
                                                 && E_1 && (!D_1)
                                                 && (J_1 == I_1)
                                                 && (L_1 == K_1))) && (A_1
                                                                       || B_1
                                                                       || N_1
                                                                       || O_1
                                                                       ||
                                                                       (!C_1)
                                                                       || (M_1
                                                                           ==
                                                                           0)
                                                                       ||
                                                                       ((!H_1)
                                                                        &&
                                                                        (!G_1)
                                                                        && F_1
                                                                        &&
                                                                        (!E_1)
                                                                        && D_1
                                                                        &&
                                                                        (J_1
                                                                         ==
                                                                         I_1)
                                                                        &&
                                                                        (L_1
                                                                         ==
                                                                         K_1)))
               && (A_1 || B_1 || N_1 || O_1 || (!C_1) || (!(M_1 == 0))
                   || ((!H_1) && (!G_1) && (!F_1) && E_1 && D_1
                       && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || C_1 || N_1
                                                             || (!O_1)
                                                             || (!B_1)
                                                             || ((!H_1) && G_1
                                                                 && (!F_1)
                                                                 && E_1
                                                                 && (!D_1)
                                                                 && (L_1 ==
                                                                     K_1)
                                                                 &&
                                                                 ((J_1 +
                                                                   (-1 *
                                                                    I_1)) ==
                                                                  -1)))
               && (A_1 || N_1 || O_1 || (!C_1) || (!B_1)
                   || ((!H_1) && (!G_1) && F_1 && (!E_1) && (!D_1)
                       && (L_1 == K_1) && ((J_1 + (-1 * I_1)) == -1))) && (A_1
                                                                           ||
                                                                           B_1
                                                                           ||
                                                                           N_1
                                                                           ||
                                                                           (!O_1)
                                                                           ||
                                                                           (!C_1)
                                                                           ||
                                                                           ((!H_1) && G_1 && (!F_1) && E_1 && D_1 && (J_1 == I_1) && ((L_1 + (-1 * K_1)) == -1))) && (A_1 || C_1 || O_1 || (!N_1) || (!B_1) || (H_1 && (!G_1) && (!F_1) && (!E_1) && D_1 && (J_1 == I_1) && (L_1 == K_1))) && (N_1 || (!O_1) || (!A_1) || (!C_1) || (!B_1) || (H_1 && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || N_1 || (!O_1) || (!C_1) || (!B_1) || ((!H_1) && G_1 && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (B_1 || C_1 || N_1 || O_1 || (!A_1) || ((!H_1) && (!G_1) && (!F_1) && E_1 && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || B_1 || C_1 || N_1 || O_1 || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || B_1 || C_1 || O_1 || (!N_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (B_1 || N_1 || O_1 || (!A_1) || (!C_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (C_1 || N_1 || (!O_1) || (!A_1) || (!B_1) || ((!H_1) && (!G_1) && (!F_1) && (!E_1) && (!D_1) && (J_1 == I_1) && (L_1 == K_1))) && (A_1 || C_1 || N_1 || O_1 || (!B_1) || ((!H_1) && (!G_1) && (!F_1) && E_1 && (!D_1) && (I_1 == 0) && (L_1 == K_1))) && (N_1 || O_1 || (!A_1) || (!C_1) || (!B_1) || ((!H_1) && G_1 && (!F_1) && (!E_1) && (!D_1) && (K_1 == 0) && (J_1 == I_1))) && (B_1 || N_1 || (!O_1) || (!A_1) || (!C_1) || (!(200 <= J_1)) || (H_1 && (!G_1) && (!F_1) && (!E_1) && D_1 && (J_1 == I_1) && (L_1 == K_1)))))
              abort ();
          state_0 = E_1;
          state_1 = D_1;
          state_2 = F_1;
          state_3 = G_1;
          state_4 = H_1;
          state_5 = I_1;
          state_6 = K_1;
          goto state_0;

      default:
          abort ();
      }

    // return expression

}

